/* 
 * TODO -einzeilige templates kann i a im props-file abspeichern, mehrzeilige 
 *       evtl. mit \n getrennt oda am andern separator, oda im notfall erstellt der 
 *       configurator halt a datei
*/


package com.nartosoft.picuploader;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSlider;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.Border;

public class PicuploaderConfigurator extends JFrame {

	private JPanel jContentPane = null; // @jve:decl-index=0:visual-constraint="395,160"

	private JPanel rootPanel = null;

	private JPanel proxyPanel = null;

	private JCheckBox proxyChk = null;

	private JTextField hostFld = null;

	private JLabel jLabel = null;

	private JTextField portFld = null;

	private JPanel logfilePanel = null;

	private JPanel leftLogfilePanel = null;

	private JPanel rightLogfilePanel = null;

	private JCheckBox logfileChk = null;

	private JPanel jPanel = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JTextField logfileFld = null;

	private JButton logfileBtn = null;

	private JCheckBox logmeldungenChk = null;

	private JCheckBox resultUrlChk = null;

	private JPanel jPanel3 = null;

	private JCheckBox fehlermeldungenChk = null;

	private JPanel templatePanel = null;

	private JCheckBox templateChk = null;

	private JTextField templateFld = null;

	private JButton templateBtn = null;

	private JPanel historyPanel = null;

	private JCheckBox historyChk = null;

	private JTextField historyFld = null;

	private JButton historyBtn = null;

	private JPanel summaryPanel = null;

	private JCheckBox summaryChk = null;

	private JTextField summaryFld = null;

	private JLabel label = null;

	private JPanel soundPanel = null;

	private JCheckBox soundChk = null;

	private JTextField soundFld = null;

	private JButton soundBtn = null;

	private JPanel scalingPanel = null;

	private JCheckBox scalingChk = null;

	private JTextField scalingFld = null;

	private JLabel jLabel9 = null;

	private JPanel trayiconPanel = null;

	private JCheckBox trayiconChk = null;

	private JPanel screenshotPanel = null;

	private JCheckBox screenshotChk = null;

	private JTextField screenshotFld = null;

	private JLabel jLabel12 = null;

	private JCheckBox showGUIChk = null;

	private JPanel outputPanel = null;

	private JTextArea outputArea = null;

	private JPanel buttonPanel = null;

	private JButton saveButton = null;

	private MouseAdapter helpCommentAdapter = null;

	private JCheckBox verboseChk = null;

	private JPanel selectionPanel = null;

	private JComboBox selectCmb = null;

	private JButton newButton = null;

	private JButton renameButton = null;

	private JButton deleteButton = null;
	
	private Vector configurations = null;

	private JPanel sendToPanel = null;

	private JButton sendToBtn = null;

	private JPanel watermarkPanel = null;

	private JPanel leftwatermarkPanel = null;

	private JPanel rightwatermarkPanel = null;

	private JCheckBox watermarkChk = null;

	private JPanel watertextPanel = null;

	private JPanel waterxorPanel = null;

	private JPanel wateryorPanel = null;

	private JPanel waterfontPanel = null;

	private JTextField watertextFld = null;

	private JButton watercolorBtn = null;

	private JSlider watercolorSld = null;

	private JRadioButton waterxorleftRd = null;

	private JRadioButton waterxorcentertRd = null;

	private JRadioButton waterxorrightRd = null;

	private JRadioButton wateryorTopRd = null;

	private JRadioButton wateryorCenterRd = null;

	private JRadioButton wateryorBottomRd = null;

	private JComboBox watertextCmb = null;
	
	private Map fontFaceNames = null;

	private JTextField watertextsizeFld = null;
	
	private Color textColor = Color.BLACK;

	private JLabel watercolorLbl = null;

	/**
	 * This is the default constructor
	 */
	public PicuploaderConfigurator() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	
	private void initFontList() {
		//Initialize Font Faces
		fontFaceNames = new HashMap();
		  
		// Get all available font faces names
		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		Font[] fonts = ge.getAllFonts();
		    
		// Process each font
		for (int i=0; i<fonts.length; i++) {
		  // Get font's family and face
		  String familyName = fonts[i].getFamily();
		  String faceName = fonts[i].getName();
		    
		  // Add font to table
		  java.util.List fontList = (java.util.List)fontFaceNames.get(familyName);
		  if (fontList == null) {
		    fontList = new ArrayList();
		    fontFaceNames.put(familyName, fontList);
		    
		  }
		  fontList.add(faceName);
		}
		    
		 // Replace the face name lists with string arrays,
		 // which are more compact and convenient to use
		 for (Iterator it=fontFaceNames.keySet().iterator(); it.hasNext(); ) {
		   String familyName = (String)it.next();
		   java.util.List list = (java.util.List)fontFaceNames.get(familyName);
		   fontFaceNames.put(familyName, list.toArray(new String[list.size()]));
		 }

	}
	private void initialize() {
		initFontList();
		helpCommentAdapter = new MouseAdapter() {   
			public void mouseExited(java.awt.event.MouseEvent e) {    
				  outputArea.setText("");	

			}
			public void mouseEntered(java.awt.event.MouseEvent e) {
				Object source = e.getSource();
				if(source==proxyChk||source==hostFld||source==portFld||source==proxyPanel) {
				  outputArea.setText("Host kann als ip-Adresse oder als Name angegeben werden.\n"+
                		             "Beispiel: 127.0.0.1 oder localhost");	
				}
				else if(source==logfileChk||source==logfileFld||source==logfileBtn||
						source==jPanel||source==leftLogfilePanel|source==logmeldungenChk||
						source==jPanel1||source==resultUrlChk||source==jPanel2||source==jPanel3||
						source==fehlermeldungenChk) {
					outputArea.setText("Das Logfile kann beliebige Endungen haben, wir empfehlen .txt oder .log");
				}
				else if(source==templateChk||source==templateFld||source==templateBtn||source==templatePanel) {
					outputArea.setText("Template Dateien haben standardmig die Endung .txt und befinden sich im Picuploader Programmverzeichnis.");
				}
				else if(source==historyChk||source==historyFld||source==historyBtn||source==historyPanel) {
					outputArea.setText("Diese Datei sollte die Endung .html bekommen um die History im vollen Umfang nutzen zu knnen.");					
				}
				else if(source==summaryChk||source==summaryFld||source==label||source==summaryPanel) {
					outputArea.setText("Dieser Parameter blendet nach erfolgtem Upload " +					
			           "rechts unten eine Kurzzusammenfassung ein.");				}
				else if(source==soundChk||source==soundFld||source==soundBtn||source==soundPanel) {
					outputArea.setText("Soll nach erfolgtem Upload ein Gerusch abgespielt werden dann" +					
					           " muss dieser Parameter aktiviert sein. Mgliche Formate sind .wav " +
         			           " .au und .aiff");
				}
				else if(source==scalingChk||source==scalingFld||source==jLabel9||source==scalingPanel) {
					outputArea.setText("Fr automatische Skalierung diesen Parameter aktivieren. " +
			           "Die angegebene Zahlt stellt die Obergrenze dar.");
				}
				else if(source==trayiconChk) {
					outputArea.setText("Hier kann ein Icon aktiviert werden, welcher whred des Uploads" +
			           " angezeigt wird. Nur .gif werden Untersttzt wenn ein animierter Icon gewnscht ist.");
				}
				else if(source==verboseChk) {
					outputArea.setText("Hier knnen debug-Meldungen aktiviert werden, normalerweise nicht notwendig.");
				}
				else if(source==watermarkChk||source==waterxorleftRd||source==waterxorcentertRd||source==waterxorrightRd
						||source==wateryorTopRd||source==wateryorCenterRd||source==wateryorBottomRd||source==waterxorPanel
						||source==watertextFld||source==watertextCmb||source==watertextsizeFld||source==watercolorBtn
						||source==watercolorSld||source==watercolorLbl) {
					outputArea.setText("Zum Hinzufgen eines Text als Wasserzeichen zum hochgeladenen Bild.");
				}
				else if(source==screenshotChk||source==screenshotFld||source==jLabel12) {
					outputArea.setText("Dient zum Hochladen von Screenshots. " +
					           "Verzgerung einstellbar, um z.B. ein anderes Fenster in " +
					           "den Vordergrund bringen zu knnen. \"Show GUI\" Parameter um " +
					           "zustzlich ein Fenster einzublenden, welches die Bearbeitung des " +
					           "Screenshots ermglicht.");
				}
				else if(source==showGUIChk) {
					outputArea.setText("Blendet vor dem Upload einen Dialog ein, in dem der Screenshot bearbeitet werden kann");

				}
				else if(source==newButton) {
					outputArea.setText("Neue Konfiguration erstellen");
				}
				else if(source==renameButton) {
					outputArea.setText("Konfiguration umbenennen");
				}
				else if(source==saveButton) {
					outputArea.setText("Konfiguration speichern");
				}
				else if(source==deleteButton) {
					outputArea.setText("Konfiguration lschen");
				}
				else if(source==sendToBtn) {
					outputArea.setText("SendTo Link fr diese Konfiguration generieren");
				}
			}
		};

		
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension d = tk.getScreenSize();
		int width = (int) d.getWidth();
		int height = (int) d.getHeight();
		this.setContentPane(getRootPanel());
		this.setTitle("Picuploader Configurator");
		this.setBounds(new java.awt.Rectangle(0,0,490,775));
		this.setLocation((width / 2 - this.getWidth() / 2), (height / 2 - this
				.getHeight() / 2));
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			}
		});
		//Group RadioButtons
		ButtonGroup group1 = new ButtonGroup();
		group1.add(waterxorleftRd);
		group1.add(waterxorcentertRd);
		group1.add(waterxorrightRd);
		ButtonGroup group2 = new ButtonGroup();
		group2.add(wateryorTopRd);
		group2.add(wateryorCenterRd);
		group2.add(wateryorBottomRd);

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
		}
		return jContentPane;
	}

	/**
	 * This method initializes rootPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getRootPanel() {
		if (rootPanel == null) {
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.gridx = 0;
			gridBagConstraints31.fill = java.awt.GridBagConstraints.BOTH;
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = 0;
			gridBagConstraints13.weighty = 0.0D;
			gridBagConstraints13.gridy = 13;
			gridBagConstraints13.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints13.weightx = 0.0D;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints21.gridy = 0;
			gridBagConstraints21.gridx = 0;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 0;
			gridBagConstraints12.weighty = 0.0D;
			gridBagConstraints12.fill = java.awt.GridBagConstraints.BOTH;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 0;
			gridBagConstraints8.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints8.weighty = 1.0D;
			gridBagConstraints8.gridy = -1;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.fill = java.awt.GridBagConstraints.BOTH;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints6.gridx = 0;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.fill = java.awt.GridBagConstraints.BOTH;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints4.gridx = 0;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints3.gridx = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints2.weightx = 1.0D;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.weightx = 1.0D;
			gridBagConstraints11.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints11.gridy = -1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridheight = 1;
			gridBagConstraints1.gridwidth = 1;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
			gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints1.weightx = 1.0D;
			gridBagConstraints1.weighty = 0.0D;
			gridBagConstraints1.gridy = GridBagConstraints.RELATIVE;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.PAGE_START;
			gridBagConstraints.weightx = 1.0D;
			gridBagConstraints.gridwidth = 1;
			gridBagConstraints.gridheight = 1;
			gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints.weighty = 0.0D;
			gridBagConstraints.gridy = 1;
			rootPanel = new JPanel();
			rootPanel.setLayout(new GridBagLayout());
			rootPanel.add(getProxyPanel(), gridBagConstraints);
			rootPanel.add(getLogfilePanel(), gridBagConstraints1);
			rootPanel.add(getTemplatePanel(), gridBagConstraints11);
			rootPanel.add(getJPanel4(), gridBagConstraints2);
			rootPanel.add(getJPanel42(), gridBagConstraints3);
			rootPanel.add(getJPanel43(), gridBagConstraints4);
			rootPanel.add(getJPanel44(), gridBagConstraints5);
			rootPanel.add(getJPanel5(), gridBagConstraints6);
			rootPanel.add(getJPanel45(), gridBagConstraints7);
			rootPanel.add(getJPanel47(), gridBagConstraints31);
			rootPanel.add(getOutputPanel(), gridBagConstraints8);
			rootPanel.add(getButtonPanel(), gridBagConstraints12);
			rootPanel.add(getSelectionPanel(), gridBagConstraints21);
			rootPanel.add(getJPanel46(), gridBagConstraints13);
		}
		return rootPanel;
	}

	/**
	 * This method initializes proxyPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getProxyPanel() {
		if (proxyPanel == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			jLabel = new JLabel();
			jLabel.setText(":");
			proxyPanel = new JPanel();
			proxyPanel.setLayout(flowLayout);
			proxyPanel.add(getProxyChk(), null);
			proxyPanel.add(getHostFld(), null);
			proxyPanel.add(jLabel, null);
			proxyPanel.add(getPortFld(), null);
			proxyPanel.addMouseListener(helpCommentAdapter);
		}
		return proxyPanel;
	}

	/**
	 * This method initializes proxyChk
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getProxyChk() {
		if (proxyChk == null) {
			proxyChk = new JCheckBox();
			proxyChk.setText("Proxy (host:port)");
			proxyChk.setToolTipText("Bei Internetanbindungen ber Proxy mssen hier die Daten hinterlegt werden");
			proxyChk.setPreferredSize(new java.awt.Dimension(120, 24));
			proxyChk.addMouseListener(helpCommentAdapter);
		}
		return proxyChk;
	}

	/**
	 * This method initializes hostFld
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getHostFld() {
		if (hostFld == null) {
			hostFld = new JTextField();
			hostFld.setColumns(12);
			hostFld.addMouseListener(helpCommentAdapter);
		}
		return hostFld;
	}

	/**
	 * This method initializes portFld
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getPortFld() {
		if (portFld == null) {
			portFld = new JTextField();
			portFld.setColumns(4);
			portFld.addMouseListener(helpCommentAdapter);
		}
		return portFld;
	}

	/**
	 * This method initializes logfilePanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getLogfilePanel() {
		if (logfilePanel == null) {
			logfilePanel = new JPanel();
			logfilePanel.setLayout(new BorderLayout());
			logfilePanel.add(getLeftLogfilePanel(), java.awt.BorderLayout.WEST);
			logfilePanel.add(getRightLogfilePanel(),
					java.awt.BorderLayout.CENTER);
		}
		return logfilePanel;
	}

	/**
	 * This method initializes leftLogfilePanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getLeftLogfilePanel() {
		if (leftLogfilePanel == null) {
			leftLogfilePanel = new JPanel();
			leftLogfilePanel.addMouseListener(helpCommentAdapter);
			leftLogfilePanel.add(getLogfileChk(), null);
		}
		return leftLogfilePanel;
	}

	/**
	 * This method initializes rightLogfilePanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getRightLogfilePanel() {
		if (rightLogfilePanel == null) {
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(4);
			gridLayout.setColumns(1);
			rightLogfilePanel = new JPanel();
			rightLogfilePanel.setLayout(gridLayout);
			rightLogfilePanel.add(getJPanel(), null);
			rightLogfilePanel.add(getJPanel1(), null);
			rightLogfilePanel.add(getJPanel2(), null);
			rightLogfilePanel.add(getJPanel3(), null);
		}
		return rightLogfilePanel;
	}

	/**
	 * This method initializes logfileChk
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getLogfileChk() {
		if (logfileChk == null) {
			logfileChk = new JCheckBox();
			logfileChk.setText("Logdatei");
			logfileChk.setToolTipText("Fr detailliertes Logging aktivieren und gewnschte Datei angeben");
			logfileChk.setPreferredSize(new java.awt.Dimension(115, 24));
			logfileChk.addMouseListener(helpCommentAdapter);
		}
		return logfileChk;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
			jPanel = new JPanel();
			jPanel.addMouseListener(helpCommentAdapter);
			jPanel.setLayout(flowLayout1);
			jPanel.add(getLogfileFld(), null);
			jPanel.add(getLogfileBtn(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setAlignment(java.awt.FlowLayout.LEFT);
			jPanel1 = new JPanel();
			jPanel1.addMouseListener(helpCommentAdapter);
			jPanel1.setLayout(flowLayout2);
			jPanel1.add(getLogmeldungenChk(), null);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			FlowLayout flowLayout3 = new FlowLayout();
			flowLayout3.setAlignment(java.awt.FlowLayout.LEFT);
			jPanel2 = new JPanel();
			jPanel2.addMouseListener(helpCommentAdapter);
			jPanel2.setLayout(flowLayout3);
			jPanel2.add(getResultUrlChk(), null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes logfileFld
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getLogfileFld() {
		if (logfileFld == null) {
			logfileFld = new JTextField();
			logfileFld.setColumns(15);
			logfileFld.addMouseListener(helpCommentAdapter);
		}
		return logfileFld;
	}

	/**
	 * This method initializes logfileBtn
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getLogfileBtn() {
		if (logfileBtn == null) {
			logfileBtn = new JButton();
			logfileBtn.setText("...");
			logfileBtn.setPreferredSize(new java.awt.Dimension(30,20));
			logfileBtn.addMouseListener(helpCommentAdapter);
			logfileBtn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JFileChooser fc = new JFileChooser();
					fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
					int returnVal = fc.showOpenDialog(null);
				    if(returnVal == JFileChooser.APPROVE_OPTION) {
					  File f = fc.getSelectedFile();
					  logfileFld.setText(f.getAbsolutePath());
				    }
				}
			});
		}
		return logfileBtn;
	}

	/**
	 * This method initializes logmeldungenChk
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getLogmeldungenChk() {
		if (logmeldungenChk == null) {
			logmeldungenChk = new JCheckBox();
			logmeldungenChk.addMouseListener(helpCommentAdapter);
			logmeldungenChk.setText("allg. Meldungen");
		}
		return logmeldungenChk;
	}

	/**
	 * This method initializes resultUrlChk
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getResultUrlChk() {
		if (resultUrlChk == null) {
			resultUrlChk = new JCheckBox();
			resultUrlChk.addMouseListener(helpCommentAdapter);
			resultUrlChk.setText("Ergebnis URL");
		}
		return resultUrlChk;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			FlowLayout flowLayout4 = new FlowLayout();
			flowLayout4.setAlignment(java.awt.FlowLayout.LEFT);
			jPanel3 = new JPanel();
			jPanel3.setLayout(flowLayout4);
			jPanel3.addMouseListener(helpCommentAdapter);
			jPanel3.add(getFehlermeldungenChk(), null);
			
		}
		return jPanel3;
	}

	/**
	 * This method initializes fehlermeldungenChk
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getFehlermeldungenChk() {
		if (fehlermeldungenChk == null) {
			fehlermeldungenChk = new JCheckBox();
			fehlermeldungenChk.addMouseListener(helpCommentAdapter);
			fehlermeldungenChk.setText("Fehlermeldungen");
		}
		return fehlermeldungenChk;
	}

	/**
	 * This method initializes templatePanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getTemplatePanel() {
		if (templatePanel == null) {
			FlowLayout flowLayout5 = new FlowLayout();
			flowLayout5.setAlignment(java.awt.FlowLayout.LEFT);
			templatePanel = new JPanel();
			templatePanel.addMouseListener(helpCommentAdapter);
			templatePanel.setLayout(flowLayout5);
			templatePanel.add(getTemplateChk(), null);
			templatePanel.add(getTemplateFld(), null);
			templatePanel.add(getTemplateBtn(), null);
		}
		return templatePanel;
	}

	/**
	 * This method initializes templateChk
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getTemplateChk() {
		if (templateChk == null) {
			templateChk = new JCheckBox();
			templateChk.setText("Template");
			templateChk.setToolTipText("Um mit Templates (fr BBBord und hnliche) arbeiten zu knnen");
			templateChk.setPreferredSize(new java.awt.Dimension(120, 24));
			templateChk.addMouseListener(helpCommentAdapter);
		}
		return templateChk;
	}

	/**
	 * This method initializes templateFld
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTemplateFld() {
		if (templateFld == null) {
			templateFld = new JTextField();
			templateFld.addMouseListener(helpCommentAdapter);
			templateFld.setColumns(15);
		}
		return templateFld;
	}

	/**
	 * This method initializes templateBtn
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getTemplateBtn() {
		if (templateBtn == null) {
			templateBtn = new JButton();
			templateBtn.setText("...");
			templateBtn.setPreferredSize(new java.awt.Dimension(30,20));
			templateBtn.addMouseListener(helpCommentAdapter);
			templateBtn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JFileChooser fc = new JFileChooser();
					fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
					int returnVal = fc.showOpenDialog(null);
				    if(returnVal == JFileChooser.APPROVE_OPTION) {
					  File f = fc.getSelectedFile();
					  templateFld.setText(f.getAbsolutePath());
				    }
				}
			});
		}
		return templateBtn;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4() {
		if (historyPanel == null) {
			FlowLayout flowLayout6 = new FlowLayout();
			flowLayout6.setAlignment(java.awt.FlowLayout.LEFT);
			historyPanel = new JPanel();
			historyPanel.addMouseListener(helpCommentAdapter);
			historyPanel.setLayout(flowLayout6);
			historyPanel.add(getJCheckBox(), null);
			historyPanel.add(getJTextField(), null);
			historyPanel.add(getJButton(), null);
		}
		return historyPanel;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox() {
		if (historyChk == null) {
			historyChk = new JCheckBox();
			historyChk.setName("historyChk");
			historyChk.addMouseListener(helpCommentAdapter);
			historyChk.setPreferredSize(new java.awt.Dimension(120, 24));
			historyChk.setToolTipText("Upload History im HTML Format");
			historyChk.setText("Upload History");
		}
		return historyChk;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField() {
		if (historyFld == null) {
			historyFld = new JTextField();
			historyFld.addMouseListener(helpCommentAdapter);
			historyFld.setColumns(15);
		}
		return historyFld;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (historyBtn == null) {
			historyBtn = new JButton();
			historyBtn.setText("...");
			historyBtn.setPreferredSize(new java.awt.Dimension(30,20));
			historyBtn.setName("historyBtn");
			historyBtn.addMouseListener(helpCommentAdapter);
			historyBtn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JFileChooser fc = new JFileChooser();
					fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
					int returnVal = fc.showOpenDialog(null);
				    if(returnVal == JFileChooser.APPROVE_OPTION) {
					  File f = fc.getSelectedFile();
					  historyFld.setText(f.getAbsolutePath());
				    }
				}
			});
		}
		return historyBtn;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel42() {
		if (summaryPanel == null) {
			label = new JLabel();
			label.setText("Sekunden");
			label.addMouseListener(helpCommentAdapter);
			FlowLayout flowLayout7 = new FlowLayout();
			flowLayout7.setAlignment(java.awt.FlowLayout.LEFT);
			summaryPanel = new JPanel();
			summaryPanel.setLayout(flowLayout7);
			summaryPanel.add(getJCheckBox2(), null);
			summaryPanel.add(getJTextField1(), null);
			summaryPanel.addMouseListener(helpCommentAdapter);
			summaryPanel.add(label, null);
		}
		return summaryPanel;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox2() {
		if (summaryChk == null) {
			summaryChk = new JCheckBox();
			summaryChk.setName("historyChk");
			summaryChk.setPreferredSize(new java.awt.Dimension(120, 24));
			summaryChk.setToolTipText("Blendet nach erfolgtem Upload oder bei Fehlern ein Informationsfenster am rechten unteren Rand fr die angegebene Zeit ein");
			summaryChk.setText("bersicht");
			summaryChk.addMouseListener(helpCommentAdapter);
		}
		return summaryChk;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField1() {
		if (summaryFld == null) {
			summaryFld = new JTextField();
			summaryFld.addMouseListener(helpCommentAdapter);
			summaryFld.setColumns(3);
			summaryFld.setText("5");
		}
		return summaryFld;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel43() {
		if (soundPanel == null) {
			FlowLayout flowLayout8 = new FlowLayout();
			flowLayout8.setAlignment(java.awt.FlowLayout.LEFT);
			soundPanel = new JPanel();
			soundPanel.addMouseListener(helpCommentAdapter);
			soundPanel.setLayout(flowLayout8);
			soundPanel.add(getJCheckBox3(), null);
			soundPanel.add(getJTextField2(), null);
			soundPanel.add(getJButton2(), null);
		}
		return soundPanel;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox3() {
		if (soundChk == null) {
			soundChk = new JCheckBox();
			soundChk.setName("historyChk");
			soundChk.addMouseListener(helpCommentAdapter);
			soundChk.setPreferredSize(new java.awt.Dimension(120, 24));
			soundChk.setToolTipText("Spielt den angegebenen Sound wenn alle Bilder hochgeladen wurden");
			soundChk.setText("Sound");
		}
		return soundChk;
	}

	/**
	 * This method initializes jTextField2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField2() {
		if (soundFld == null) {
			soundFld = new JTextField();
			soundFld.addMouseListener(helpCommentAdapter);
			soundFld.setColumns(15);
		}
		return soundFld;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton2() {
		if (soundBtn == null) {
			soundBtn = new JButton();
			soundBtn.setName("historyBtn");
			soundBtn.setPreferredSize(new java.awt.Dimension(30,20));
			soundBtn.setText("...");
			soundBtn.addMouseListener(helpCommentAdapter);
			soundBtn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					JFileChooser fc = new JFileChooser();
					fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
					fc.setFileFilter(new AudioFilter());
					int returnVal = fc.showOpenDialog(null);
				    if(returnVal == JFileChooser.APPROVE_OPTION) {
					  File f = fc.getSelectedFile();
					  soundFld.setText(f.getAbsolutePath());
				    }
				}
			});
		}
		return soundBtn;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel44() {
		if (scalingPanel == null) {
			jLabel9 = new JLabel();
			jLabel9.addMouseListener(helpCommentAdapter);
			jLabel9.setText("kb");
			FlowLayout flowLayout9 = new FlowLayout();
			flowLayout9.setAlignment(java.awt.FlowLayout.LEFT);
			scalingPanel = new JPanel();
			scalingPanel.setLayout(flowLayout9);
			scalingPanel.addMouseListener(helpCommentAdapter);
			scalingPanel.add(getJCheckBox4(), null);
			scalingPanel.add(getJTextField3(), null);
			scalingPanel.add(jLabel9, null);
		}
		return scalingPanel;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox4() {
		if (scalingChk == null) {
			scalingChk = new JCheckBox();
			scalingChk.setName("historyChk");
			scalingChk.addMouseListener(helpCommentAdapter);
			scalingChk.setPreferredSize(new java.awt.Dimension(120, 24));
			scalingChk.setToolTipText("Bilder werden automatisch auf eine Dateigre gebracht, die kleiner ist als der angegebene Wert");
			scalingChk.setText("Aut. Skalierung");
		}
		return scalingChk;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField3() {
		if (scalingFld == null) {
			scalingFld = new JTextField();
			scalingFld.addMouseListener(helpCommentAdapter);
			scalingFld.setColumns(3);
			scalingFld.setText("666");
		}
		return scalingFld;
	}

	/**
	 * This method initializes jPanel5
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel5() {
		if (trayiconPanel == null) {
			FlowLayout flowLayout10 = new FlowLayout();
			flowLayout10.setAlignment(java.awt.FlowLayout.LEFT);
			trayiconPanel = new JPanel();
			trayiconPanel.setLayout(flowLayout10);
			trayiconPanel.add(getJCheckBox5(), null);
			trayiconPanel.add(getVerboseChk(), null);
		}
		return trayiconPanel;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox5() {
		if (trayiconChk == null) {
			trayiconChk = new JCheckBox();
			trayiconChk.setName("historyChk");
			trayiconChk.addMouseListener(helpCommentAdapter);
			trayiconChk.setPreferredSize(new java.awt.Dimension(120, 24));
			trayiconChk.setToolTipText("Icon, welches im Tray erscheint, whrend das Programm luft");
			trayiconChk.setText("Trayicon");
		}
		return trayiconChk;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel45() {
		if (screenshotPanel == null) {
			jLabel12 = new JLabel();
			jLabel12.addMouseListener(helpCommentAdapter);
			jLabel12.setText("Sekunden");
			FlowLayout flowLayout11 = new FlowLayout();
			flowLayout11.setAlignment(java.awt.FlowLayout.LEFT);
			screenshotPanel = new JPanel();
			screenshotPanel.setLayout(flowLayout11);
			screenshotPanel.add(getJCheckBox6(), null);
			screenshotPanel.add(getJTextField5(), null);
			screenshotPanel.add(jLabel12, null);
			screenshotPanel.add(getShowGUIChk(), null);
		}
		return screenshotPanel;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox6() {
		if (screenshotChk == null) {
			screenshotChk = new JCheckBox();
			screenshotChk.addMouseListener(helpCommentAdapter);
			screenshotChk.setName("historyChk");
			screenshotChk.setPreferredSize(new java.awt.Dimension(120, 24));
			screenshotChk
					.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			screenshotChk.setToolTipText("Ermglicht einen Screenshot zu machen und bei 666kb.com hochzuladen");
			screenshotChk.setText("Screenshot");
		}
		return screenshotChk;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField5() {
		if (screenshotFld == null) {
			screenshotFld = new JTextField();
			screenshotFld.addMouseListener(helpCommentAdapter);
			screenshotFld.setColumns(3);
		}
		return screenshotFld;
	}

	/**
	 * This method initializes showGUIChk
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getShowGUIChk() {
		if (showGUIChk == null) {
			showGUIChk = new JCheckBox();
			showGUIChk.addMouseListener(helpCommentAdapter);
			showGUIChk.setText("Show GUI");
			showGUIChk.setToolTipText("Blendet vor dem Upload einen Dialog ein, in dem der Screenshot bearbeitet werden kann");
		}
		return showGUIChk;
	}

	/**
	 * This method initializes outputPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getOutputPanel() {
		if (outputPanel == null) {
			outputPanel = new JPanel();
			outputPanel.setLayout(new BorderLayout());
			outputPanel.add(getOutputArea(), java.awt.BorderLayout.CENTER);
			Border b = BorderFactory.createTitledBorder("Erklrung");
			outputPanel.setBorder(b);
		}
		return outputPanel;
	}

	/**
	 * This method initializes outputArea
	 * 
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getOutputArea() {
		if (outputArea == null) {
			outputArea = new JTextArea();
			outputArea.setRows(5);
			outputArea.setLineWrap(true);
			outputArea.setEditable(false);
			outputArea.setWrapStyleWord(true);
			outputArea.setColumns(40);
		}
		return outputArea;
	}

	public void generateParameters() {
		String s = "";
		if (this.proxyChk.isSelected()) {// -p
			String host = this.hostFld.getText();
			String port = this.portFld.getText();
			if (!host.equalsIgnoreCase("")&& !port.equalsIgnoreCase("")) {
				s += "-p " + host + ":" + port + " ";
			}
		}
		if (this.logfileChk.isSelected()) {// -f
			String fileName = this.logfileFld.getText();
			if (!fileName.equalsIgnoreCase("")) {
				s += "-f " + fileName + " -ff ";
				if (this.logmeldungenChk.isSelected()) {
					s += "i";
				}
				if (this.resultUrlChk.isSelected()) {
					s += "u";
				}
				if (this.fehlermeldungenChk.isSelected()) {
					s += "e";
				}
				s += " ";
			}
		}
		if (this.templateChk.isSelected()) {// t
			String fileName = this.templateFld.getText();
			if (!fileName.equalsIgnoreCase("")) {
				s += "-t " + fileName + " ";
			}
		}
		if (this.historyChk.isSelected()) {// h
			String fileName = this.historyFld.getText();
			if (!fileName.equalsIgnoreCase("")) {
				s += "-h " + fileName + " ";
			}
		}
		if (this.summaryChk.isSelected()) {// summary
			if (!this.summaryFld.getText().equalsIgnoreCase("")) {
				s += "-summary " + this.summaryFld.getText() + " ";
			}
		}
		if (this.soundChk.isSelected()) {// sound
			String fileName = this.soundFld.getText();
			if (!fileName.equalsIgnoreCase("")) {
				s += "-sound " + fileName + " ";
			}
		}
		if (this.scalingChk.isSelected()) {
			if (!this.scalingFld.getText().equalsIgnoreCase("")) {
				s += "-autoscale " + this.scalingFld.getText() + " ";
			}
		}
		if (this.trayiconChk.isSelected()) {
			String fileName = "./ressources/upload.gif"; 
				s += "-trayicon " + fileName + " ";
			
		}
		if (this.screenshotChk.isSelected()) {
			if (!this.screenshotFld.getText().equalsIgnoreCase("")) {
				s += "-screenshot " + this.screenshotFld.getText() + " ";
			}
			if (this.showGUIChk.isSelected()) {
				s += "-showgui" + " ";
			}
		}
		
		this.outputArea.setText(s);
	}

	/**
	 * This method initializes buttonPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getButtonPanel() {
		if (buttonPanel == null) {
			buttonPanel = new JPanel();
			buttonPanel.setPreferredSize(new java.awt.Dimension(593,46));
			buttonPanel.add(getNewButton(), null);
			buttonPanel.add(getRenameButton(), null);
			buttonPanel.add(getSaveButton(), null);
			buttonPanel.add(getDeleteButton(), null);
		}
		return buttonPanel;
	}

	/**
	 * This method initializes saveButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSaveButton() {
		if (saveButton == null) {
			saveButton = new JButton();
			saveButton.setText("Speichern");
			saveButton.setPreferredSize(new java.awt.Dimension(109,26));
			saveButton.addMouseListener(helpCommentAdapter);
			saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveConfig();
				}
			});
		}
		return saveButton;
	}
	
	public void saveConfig() {
        String configName = (String)selectCmb.getSelectedItem();
        if(configName!=null) {
      	  File f = new File("./configurations/"+configName+".config");
			  saveConfigFile(f);
        }		
	}
	
	public void saveConfigFile(File f) {
		Properties props = new Properties();
		if (this.proxyChk.isSelected()) {// -p
			String host = this.hostFld.getText();
			String port = this.portFld.getText();
			if (!host.equalsIgnoreCase("")&& !port.equalsIgnoreCase("")) {
				props.setProperty("proxy", host+":"+port);
			}
		}
		if (this.logfileChk.isSelected()) {// -f
			String logFileName = this.logfileFld.getText();
			if (!logFileName.equalsIgnoreCase("")) {
				props.setProperty("logFile", logFileName);
				String logParameters = "";
				if (this.logmeldungenChk.isSelected()) {
					logParameters += "i";
				}
				if (this.resultUrlChk.isSelected()) {
					logParameters += "u";
				}
				if (this.fehlermeldungenChk.isSelected()) {
					logParameters += "e";
				}
				props.setProperty("logParameters", logParameters);
			}
		}
		if (this.templateChk.isSelected()) {// t
			String templateName = this.templateFld.getText();
			if (!templateName.equalsIgnoreCase("")) {
				props.setProperty("templateName", templateName);
			}
		}
		if (this.historyChk.isSelected()) {// h
			String histFileName = this.historyFld.getText();
			if (!histFileName.equalsIgnoreCase("")) {
				props.setProperty("historyFileName", histFileName);
			}
		}
		if (this.summaryChk.isSelected()) {// summary
			if (!this.summaryFld.getText().equalsIgnoreCase("")) {
				props.setProperty("summary", this.summaryFld.getText());
			}
		}
		if (this.soundChk.isSelected()) {// sound
			String soundFileName = this.soundFld.getText();
			if (!soundFileName.equalsIgnoreCase("")) {
				props.setProperty("soundFileName", soundFileName);
			}
		}
		if (this.scalingChk.isSelected()) {
			if (!this.scalingFld.getText().equalsIgnoreCase("")) {
				props.setProperty("autoscale", this.scalingFld.getText());
			}
		}
		if (this.trayiconChk.isSelected()) {
			String trayFileName = new File("./ressources/upload.gif").getAbsolutePath();
    		props.setProperty("trayicon", trayFileName);
		}
		if (this.verboseChk.isSelected()) {
    		props.setProperty("verbose", "true");
		}
		if (this.screenshotChk.isSelected()) {
			if (!this.screenshotFld.getText().equalsIgnoreCase("")) {
				props.setProperty("screenshot", this.screenshotFld.getText());
			}
			if (this.showGUIChk.isSelected()) {
				props.setProperty("showgui", "true");
			}
		}
		if(this.watermarkChk.isSelected()) {
			props.setProperty("watermark", this.watertextFld.getText());
			if(this.waterxorleftRd.isSelected()) {
				props.setProperty("xor", Watermark.LEFT+"");
			} else if(this.waterxorcentertRd.isSelected()) {
				props.setProperty("xor", Watermark.CENTER+"");
			} else if(this.waterxorrightRd.isSelected()) {
				props.setProperty("xor", Watermark.RIGHT+"");
			}
			if(this.wateryorTopRd.isSelected()) {
				props.setProperty("yor", Watermark.TOP+"");
			} else if(this.wateryorCenterRd.isSelected()) {
				props.setProperty("yor", Watermark.CENTER+"");
			} else if(this.wateryorBottomRd.isSelected()) {
				props.setProperty("yor", Watermark.BOTTOM+"");
			}
			props.setProperty("fontface", this.watertextCmb.getSelectedItem()+"");
			props.setProperty("fontsize", this.watertextsizeFld.getText());
			Color c = textColor;
			String cs = c.getRed()+","+c.getGreen()+","+c.getBlue()+","+c.getAlpha();
			props.setProperty("fontcolor", cs);
		}
		try {
		  FileOutputStream fs = new FileOutputStream(f);
		  props.store(fs, "Picuploader Configuration");
		  fs.flush();
		  fs.close();
		  outputArea.setText("Konfiguration unter " + f.getAbsoluteFile() + " erfolgreich gespeichert.");
		}catch(Exception e) {
		  e.printStackTrace();	  
		}
	
	}

	public void loadConfigFile(File f) {
		reset();
		try {
			FileInputStream fs = new FileInputStream(f);
			Properties props = new Properties();
			props.load(fs);
			  if(props.containsKey("proxy")) {
				this.proxyChk.setSelected(true);
				String s = props.getProperty("proxy");
				int i = s.indexOf(":");
				if(i!=-1) {
					this.hostFld.setText(s.substring(0, i));
					this.portFld.setText(s.substring(i+1, s.length()));
				}
			  }
			  if(props.containsKey("logFile")) {
				  this.logfileChk.setSelected(true);
				  this.logfileFld.setText(props.getProperty("logFile"));
			  }
			  if(props.containsKey("logParameters")) {
				  String parameters = props.getProperty("logParameters");
				  if(parameters.indexOf("u")!=-1) {
					  this.resultUrlChk.setSelected(true);
				  }
				  if(parameters.indexOf("e")!=-1) {
					  this.fehlermeldungenChk.setSelected(true);
				  }
				  if(parameters.indexOf("i")!=-1) {
					  this.logmeldungenChk.setSelected(true);
				  }
			  }
			  if(props.containsKey("templateName")) {
				  this.templateChk.setSelected(true);
				  this.templateFld.setText(props.getProperty("templateName"));
			  }
			  if(props.containsKey("historyFileName")) {
				  this.historyChk.setSelected(true);
				  this.historyFld.setText(props.getProperty("historyFileName"));
			  }
			  if(props.containsKey("summary")) {
				  this.summaryChk.setSelected(true);
				  this.summaryFld.setText(props.getProperty("summary"));
			  }
			  if(props.containsKey("soundFileName")) {
				  this.soundChk.setSelected(true);
				  this.soundFld.setText(props.getProperty("soundFileName"));
			  }
			  if(props.containsKey("autoscale")) {
				  this.scalingChk.setSelected(true);
				  this.scalingFld.setText(props.getProperty("autoscale"));
			  }
			  if(props.containsKey("trayicon")) {
				  this.trayiconChk.setSelected(true);
			  }
			  if(props.containsKey("verbose")) {
				  this.verboseChk.setSelected(true);
			  }
			  if(props.containsKey("screenshot")) {
				  this.screenshotChk.setSelected(true);
				  this.screenshotFld.setText(props.getProperty("screenshot"));
			  }
			  if(props.containsKey("showgui")) {
				  String s = props.getProperty("showgui");
				  if(s.equalsIgnoreCase("true")) {
					  this.showGUIChk.setSelected(true);
				  }
			  }
			  if(props.containsKey("watermark")) {
				  this.watertextFld.setText(props.getProperty("watermark"));
				  this.watermarkChk.setSelected(true);
				  int count = this.watertextCmb.getItemCount();
				  int index = -1;
				  String lookFor = props.getProperty("fontface");
				  for(int i = 0; i<count; i++){
					  String compTo = (String)this.watertextCmb.getItemAt(i);
					  if(compTo.equalsIgnoreCase(lookFor)) {
						  index = i;
					  }
				  }
				  this.watertextCmb.setSelectedIndex(index);
				  if(index!=-1) {
					  Font font = new Font(lookFor, Font.PLAIN, 12);
					  this.watertextsizeFld.setText(props.getProperty("fontsize"));
					  this.watercolorLbl.setFont(font);
				  }
				  StringTokenizer st = new StringTokenizer(props.getProperty("fontcolor"), ",");
				  int r = Integer.parseInt(st.nextToken());
				  int g = Integer.parseInt(st.nextToken());
				  int b = Integer.parseInt(st.nextToken());
				  int a = Integer.parseInt(st.nextToken());
				  Color c = new Color(r,g,b,a);
				  this.watercolorLbl.setForeground(c);
				  this.textColor = c;
				  this.watercolorSld.setValue(a);
				  int xor = Integer.parseInt(props.getProperty("xor"));
				  int yor = Integer.parseInt(props.getProperty("yor"));
				  if(xor==Watermark.LEFT) {
					  this.waterxorleftRd.setSelected(true);
				  } else if(xor==Watermark.CENTER) {
					  this.waterxorcentertRd.setSelected(true);
				  } else if(xor==Watermark.RIGHT) {
					  this.waterxorrightRd.setSelected(true);
				  }
				  if(yor==Watermark.TOP) {
					  this.wateryorTopRd.setSelected(true);
				  } else if(yor==Watermark.CENTER) {
					  this.wateryorCenterRd.setSelected(true);
				  } else if(yor==Watermark.BOTTOM) {
					  this.wateryorBottomRd.setSelected(true);
				  }
			  }

		}catch(Exception e) {
			outputArea.setText("Fehler beim Lesen von " + f.getAbsoluteFile()+": "+e.getMessage());
		}
	}

	/**
	 * This method initializes verboseChk	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getVerboseChk() {
		if (verboseChk == null) {
			verboseChk = new JCheckBox();
			verboseChk.addMouseListener(helpCommentAdapter);
			verboseChk.setText("Debug Nachrichten");
		}
		return verboseChk;
	}

	/**
	 * This method initializes selectionPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSelectionPanel() {
		if (selectionPanel == null) {
			selectionPanel = new JPanel();
			selectionPanel.setLayout(new BorderLayout());
			selectionPanel.setPreferredSize(new java.awt.Dimension(332,30));
			selectionPanel.add(getSelectCmb(), java.awt.BorderLayout.NORTH);
		}
		return selectionPanel;
	}

	/**
	 * This method initializes selectCmb	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getSelectCmb() {
		if (selectCmb == null) {
			configurations = loadConfigurations();
			selectCmb = new JComboBox(configurations);
			selectCmb.setPreferredSize(new java.awt.Dimension(350,22));
			selectCmb.setSelectedIndex(-1);
			selectCmb.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int index = selectCmb.getSelectedIndex();
					if(index>-1) {
						File f = new File("./configurations/"+(String)selectCmb.getSelectedItem()+".config");
						loadConfigFile(f);
					}
				}
			});
		}
		return selectCmb;
	}
	
	private Vector loadConfigurations() {
		Vector v = new Vector();
		File f = new File("./configurations/");
		if(f.isDirectory()) {
			File[] theFiles = f.listFiles();
			for(int i = 0; i<theFiles.length; i++) {
				File tmpFile = theFiles[i];
				if(tmpFile.isFile()&& tmpFile.getName().endsWith(".config")) {
				  v.add(tmpFile.getName().substring(0, tmpFile.getName().length()-7));
				}
			}
		}
		return v;
	}

	/**
	 * This method initializes newButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getNewButton() {
		if (newButton == null) {
			newButton = new JButton();
			newButton.setText("Neu");
			newButton.addMouseListener(helpCommentAdapter);
			newButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String input = JOptionPane.showInputDialog("Geben Sie den Namen der neuen Konfiguration an:");
					if(input!=null) {
						String configName = input.replace(' ', '_'); //perhaps not really necessary?
						reset();
						addNewConfig(configName);
						
					}
				}
			});
			newButton.setPreferredSize(new java.awt.Dimension(109,26));
		}
		return newButton;
	}
	
	public void addNewConfig(String configName) {
		File f = new File("./configurations/"+configName+".config");
		if(!f.exists()) {
		  configurations.add(configName);
		  Collections.sort(configurations);
		  selectCmb.setModel(new DefaultComboBoxModel(configurations));
		  selectCmb.setSelectedIndex(configurations.indexOf(configName));
		}
		else {
			outputArea.setText("Diese Konfiguration existiert bereits!");
		}
	}
	
	public void reset() {
		this.proxyChk.setSelected(false);
		this.hostFld.setText("");
		this.portFld.setText("");
		this.logfileChk.setSelected(false);
		this.logfileFld.setText("");
		this.logmeldungenChk.setSelected(false);
		this.resultUrlChk.setSelected(false);
		this.fehlermeldungenChk.setSelected(false);
		this.templateChk.setSelected(false);
		this.templateFld.setText("");
		this.historyChk.setSelected(false);
		this.historyFld.setText("");
		this.summaryChk.setSelected(false);
		this.summaryFld.setText("5");
		this.soundChk.setSelected(false);
		this.soundFld.setText("");
		this.scalingChk.setSelected(false);
		this.scalingFld.setText("666");
		this.trayiconChk.setSelected(false);
		this.verboseChk.setSelected(false);
		this.screenshotChk.setSelected(false);
		this.screenshotFld.setText("");
		this.showGUIChk.setSelected(false);
		this.watermarkChk.setSelected(false);
		this.watertextFld.setText("Text");
		this.waterxorcentertRd.setSelected(true);
		this.wateryorCenterRd.setSelected(true);
		this.watertextCmb.setSelectedIndex(-1);
		this.watertextsizeFld.setText("12");
		this.textColor = Color.BLACK;
		this.watercolorSld.setValue(255);
		this.watercolorLbl.setForeground(textColor);
		this.watercolorLbl.setFont(new Font("Arial", Font.PLAIN, 12));
	}

	/**
	 * This method initializes renameButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getRenameButton() {
		if (renameButton == null) {
			renameButton = new JButton();
			renameButton.setText("Umbenennen");
			renameButton.addMouseListener(helpCommentAdapter);
			renameButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String input = JOptionPane.showInputDialog("Geben Sie den neuen Namen der Konfiguration an:");
					if(input!=null) {
						renameConfig(input.replace(' ', '_'));
					}
				}
			});
		}
		return renameButton;
	}
	
	public void renameConfig(String newName) {//TODO this needs testing!
		File f = new File("./configurations/"+newName+".config");
		if(!f.exists()) {
	        String s = (String)selectCmb.getSelectedItem();
	        if(s!=null) {
			  File oldFile = new File("./configurations/"+s+".config");
			  if(oldFile.exists()) {
				  oldFile.renameTo(f);
				  selectCmb.setModel(new DefaultComboBoxModel(loadConfigurations()));
				  selectCmb.setSelectedItem(newName);
			  }
	        }
		}
	}

	/**
	 * This method initializes deleteButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getDeleteButton() {
		if (deleteButton == null) {
			deleteButton = new JButton();
			deleteButton.setText("Lschen");
			deleteButton.addMouseListener(helpCommentAdapter);
			deleteButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					deleteConfig();
				}
			});
			deleteButton.setPreferredSize(new java.awt.Dimension(109,26));
		}
		return deleteButton;
	}
	
	public void deleteConfig() {
		Object o = selectCmb.getSelectedItem();
		if(o!=null) {
			String configuration = (String)o;
			File f = new File("./configurations/"+configuration+".config");
			if(f.exists()) {
				f.delete();
			}
			selectCmb.removeItem(o);
			reset();
			selectCmb.setSelectedIndex(-1);
		}
	
	}

	/**
	 * This method initializes jPanel4	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel46() {
		if (sendToPanel == null) {
			FlowLayout flowLayout12 = new FlowLayout();
			flowLayout12.setAlignment(java.awt.FlowLayout.CENTER);
			sendToPanel = new JPanel();
			sendToPanel.setLayout(flowLayout12);
			sendToPanel.add(getSendToBtn(), null);
		}
		return sendToPanel;
	}

	/**
	 * This method initializes sendToBtn	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSendToBtn() {
		if (sendToBtn == null) {
			sendToBtn = new JButton();
			sendToBtn.setText("SendTo generieren");
			sendToBtn.setPreferredSize(new java.awt.Dimension(149,26));
			sendToBtn.addMouseListener(helpCommentAdapter);
			sendToBtn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveConfig();
					createLink();
				}
			});
		}
		return sendToBtn;
	}
	
	public void createLink() {
		Object configName = selectCmb.getSelectedItem();
		String name = JOptionPane.showInputDialog("Geben Sie den Namen der Verknpfung an:");
        if(name!=null&&configName!=null) {
		  JFileChooser fc = new JFileChooser();
		  fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
		  fc.setFileFilter(new IconFilter());
		  int returnVal = fc.showOpenDialog(null);
	      if(returnVal == JFileChooser.APPROVE_OPTION) {
		    File f = fc.getSelectedFile();
		    LinkManager.createSendToLink(name, "-jar Picuploader.jar " + configName+".config", f.getAbsolutePath());
	      }
		  
        }
	}

	/**
	 * This method initializes jPanel4	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel47() {
		if (watermarkPanel == null) {
			watermarkPanel = new JPanel();
			watermarkPanel.setLayout(new BorderLayout());
			watermarkPanel.setPreferredSize(new java.awt.Dimension(458,330));
			watermarkPanel.add(getJPanel48(), java.awt.BorderLayout.WEST);
			watermarkPanel.add(getJPanel52(), java.awt.BorderLayout.CENTER);
		}
		return watermarkPanel;
	}

	/**
	 * This method initializes jPanel4	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel48() {
		if (leftwatermarkPanel == null) {
			leftwatermarkPanel = new JPanel();
			leftwatermarkPanel.setPreferredSize(new java.awt.Dimension(120,200));
			leftwatermarkPanel.add(getWatermarkChk(), null);
		}
		return leftwatermarkPanel;
	}

	/**
	 * This method initializes jPanel5	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel52() {
		if (rightwatermarkPanel == null) {
			GridLayout gridLayout1 = new GridLayout();
			gridLayout1.setRows(4);
			gridLayout1.setColumns(1);
			rightwatermarkPanel = new JPanel();
			rightwatermarkPanel.setPreferredSize(new java.awt.Dimension(333,230));
			rightwatermarkPanel.setLayout(gridLayout1);
			rightwatermarkPanel.add(getWaterxorPanel(), null);
			rightwatermarkPanel.add(getWateryorPanel(), null);
			rightwatermarkPanel.add(getWatertextPanel(), null);
			rightwatermarkPanel.add(getWaterfontPanel(), null);
		}
		return rightwatermarkPanel;
	}

	/**
	 * This method initializes watermarkChk	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getWatermarkChk() {
		if (watermarkChk == null) {
			watermarkChk = new JCheckBox();
			watermarkChk.setText("Watermark");
			watermarkChk.setName("watermarkChk");
			watermarkChk.setPreferredSize(new java.awt.Dimension(110,24));
			watermarkChk.setHorizontalAlignment(javax.swing.SwingConstants.LEADING);
			watermarkChk.addMouseListener(helpCommentAdapter);
		}
		return watermarkChk;
	}

	/**
	 * This method initializes watertextPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getWatertextPanel() {
		if (watertextPanel == null) {
			watertextPanel = new JPanel();
			watertextPanel.add(getWatertextFld(), null);
			watertextPanel.add(getWatertextCmb(), null);
			watertextPanel.add(getWatertextsizeFld(), null);
		}
		return watertextPanel;
	}

	/**
	 * This method initializes waterxorPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getWaterxorPanel() {
		if (waterxorPanel == null) {
			waterxorPanel = new JPanel();
			waterxorPanel.setPreferredSize(new java.awt.Dimension(215,34));
			waterxorPanel.add(getWaterxorleftRd(), null);
			waterxorPanel.add(getWaterxorcentertRd(), null);
			waterxorPanel.add(getWaterxorrightRd(), null);
		}
		return waterxorPanel;
	}

	/**
	 * This method initializes wateryorPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getWateryorPanel() {
		if (wateryorPanel == null) {
			wateryorPanel = new JPanel();
			wateryorPanel.add(getWateryorTopRd(), null);
			wateryorPanel.add(getWateryorCenterRd(), null);
			wateryorPanel.add(getWateryorBottomRd(), null);
		}
		return wateryorPanel;
	}

	/**
	 * This method initializes waterfontPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getWaterfontPanel() {
		if (waterfontPanel == null) {
			watercolorLbl = new JLabel();
			watercolorLbl.setText("Vorschau");
			watercolorLbl.addMouseListener(helpCommentAdapter);
			watercolorLbl.setBackground(java.awt.Color.black);
			watercolorLbl.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			watercolorLbl.setPreferredSize(new java.awt.Dimension(80,24));
			waterfontPanel = new JPanel();
			waterfontPanel.add(getWatercolorBtn(), null);
			waterfontPanel.add(getWatercolorSld(), null);
			waterfontPanel.add(watercolorLbl, null);
		
		}
		return waterfontPanel;
	}

	/**
	 * This method initializes watertextFld	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getWatertextFld() {
		if (watertextFld == null) {
			watertextFld = new JTextField();
			watertextFld.setColumns(10);
			watertextFld.setPreferredSize(new java.awt.Dimension(320,20));
			watertextFld.setText("Text");
			watertextFld.addMouseListener(helpCommentAdapter);
		}
		return watertextFld;
	}

	/**
	 * This method initializes watercolorBtn	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getWatercolorBtn() {
		if (watercolorBtn == null) {
			watercolorBtn = new JButton();
			watercolorBtn.setText("Farbe");
			watercolorBtn.setPreferredSize(new java.awt.Dimension(115,26));
			watercolorBtn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					Color c = JColorChooser.showDialog(rootPanel, "Textfarbe whlen", textColor);
					textColor = new Color(c.getRed(), c.getGreen(), c.getBlue(), watercolorSld.getValue());
					watercolorLbl.setForeground(textColor);
				}
			});
		}
		watercolorBtn.addMouseListener(helpCommentAdapter);
		return watercolorBtn;
	}

	/**
	 * This method initializes watercolorSld	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getWatercolorSld() {
		if (watercolorSld == null) {
			watercolorSld = new JSlider();
			watercolorSld.setMaximum(255);
			watercolorSld.setValue(255);
			watercolorSld.setPaintTicks(false);
			watercolorSld.setSnapToTicks(false);
			watercolorSld.setPreferredSize(new java.awt.Dimension(130,16));
			watercolorSld.addMouseListener(helpCommentAdapter);
			watercolorSld.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					Color c = textColor;
					textColor = new Color(c.getRed(), c.getGreen(), c.getBlue(), watercolorSld.getValue());
					watercolorLbl.setForeground(textColor);
				}
			});
		}
		return watercolorSld;
	}

	/**
	 * This method initializes waterxorleftRd	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getWaterxorleftRd() {
		if (waterxorleftRd == null) {
			waterxorleftRd = new JRadioButton();
			waterxorleftRd.setText("Links");
			waterxorleftRd.setPreferredSize(new java.awt.Dimension(65,24));
			waterxorleftRd.setPreferredSize(new java.awt.Dimension(65,24));
			waterxorleftRd.addMouseListener(helpCommentAdapter);
		}
		return waterxorleftRd;
	}

	/**
	 * This method initializes waterxorcentertRd	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getWaterxorcentertRd() {
		if (waterxorcentertRd == null) {
			waterxorcentertRd = new JRadioButton();
			waterxorcentertRd.setText("Mitte");
			waterxorcentertRd.setPreferredSize(new java.awt.Dimension(65,24));
			waterxorcentertRd.setSelected(true);
			waterxorcentertRd.setPreferredSize(new java.awt.Dimension(65,24));
			waterxorcentertRd.addMouseListener(helpCommentAdapter);
		}
		return waterxorcentertRd;
	}

	/**
	 * This method initializes waterxorrightRd	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getWaterxorrightRd() {
		if (waterxorrightRd == null) {
			waterxorrightRd = new JRadioButton();
			waterxorrightRd.setText("Rechts");
			waterxorrightRd.addMouseListener(helpCommentAdapter);
		}
		return waterxorrightRd;
	}

	/**
	 * This method initializes wateryorTopRd	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getWateryorTopRd() {
		if (wateryorTopRd == null) {
			wateryorTopRd = new JRadioButton();
			wateryorTopRd.setText("Oben");
			wateryorTopRd.setPreferredSize(new java.awt.Dimension(65,24));
			wateryorTopRd.setPreferredSize(new java.awt.Dimension(65,24));
			wateryorTopRd.addMouseListener(helpCommentAdapter);
		}
		return wateryorTopRd;
	}

	/**
	 * This method initializes jwateryorCenterRd	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getWateryorCenterRd() {
		if (wateryorCenterRd == null) {
			wateryorCenterRd = new JRadioButton();
			wateryorCenterRd.setText("Mitte");
			wateryorCenterRd.setPreferredSize(new java.awt.Dimension(65,24));
			wateryorCenterRd.setSelected(true);
			wateryorCenterRd.setPreferredSize(new java.awt.Dimension(65,24));
			wateryorCenterRd.addMouseListener(helpCommentAdapter);
		}
		return wateryorCenterRd;
	}

	/**
	 * This method initializes wateryorBottomRd	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getWateryorBottomRd() {
		if (wateryorBottomRd == null) {
			wateryorBottomRd = new JRadioButton();
			wateryorBottomRd.setText("Unten");
			wateryorBottomRd.setPreferredSize(new java.awt.Dimension(65,24));
			wateryorBottomRd.setPreferredSize(new java.awt.Dimension(65,24));
			wateryorBottomRd.addMouseListener(helpCommentAdapter);
		}
		return wateryorBottomRd;
	}

	/**
	 * This method initializes watertextCmb	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getWatertextCmb() {
		if (watertextCmb == null) {
			ArrayList list = new ArrayList();
			Iterator it = fontFaceNames.keySet().iterator();
			while(it.hasNext()) {
				String[] tmp = (String[])fontFaceNames.get(it.next());
				for(int i= 0; i<tmp.length; i++) {
					list.add(tmp[i]);
				}
			}
			Collections.sort(list);
			watertextCmb = new JComboBox(list.toArray());
			watertextCmb.setSelectedIndex(-1);
			watertextCmb.setPreferredSize(new java.awt.Dimension(150,25));
			watertextCmb.addMouseListener(helpCommentAdapter);
			watertextCmb.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(watertextCmb.getSelectedItem()!=null) {
						Font f = new Font((String)watertextCmb.getSelectedItem(), Font.PLAIN, 12);
						watercolorLbl.setFont(f);
					}
				}
			});
		}
		return watertextCmb;
	}

	/**
	 * This method initializes watertextsizeFld	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getWatertextsizeFld() {
		if (watertextsizeFld == null) {
			watertextsizeFld = new JTextField();
			watertextsizeFld.setColumns(3);
			watertextsizeFld.setText("12");
			watertextsizeFld.addMouseListener(helpCommentAdapter);
		}
		return watertextsizeFld;
	}

	public static void main(String[] args) {
		new PicuploaderConfigurator().show();
	}

} // @jve:decl-index=0:visual-constraint="184,28"

class AudioFilter extends javax.swing.filechooser.FileFilter {
    public boolean accept(File file) {
    	if(file.isDirectory()) {
    		return true;
    	}
        String fn = file.getName();
        if(fn.endsWith(".wav")||fn.endsWith(".au")||fn.endsWith(".aiff")) {
          return true;
        }
        return false;
    }
    public String getDescription() {
        return "Audio Dateien (.wav, .au, .aiff)";
    }
}

class IconFilter extends javax.swing.filechooser.FileFilter {
    public boolean accept(File file) {
    	if(file.isDirectory()) {
    		return true;
    	}
        String fn = file.getName();
        if(fn.endsWith(".ico")) {
          return true;
        }
        return false;
    }
    public String getDescription() {
        return "Icons (.ico)";
    }
}

